/*
 * Haruldaselt rudimentaarne MSSQL ja Sybase klient. Pritsib
 * protokolli TDS ver. 4.2.
 *
 * Mina (st. Arno) pole milleski syydi, mis ka ei juhtuks!!!!!
 */

#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "mssql.h"

int
socket_wrapper_connect(MSSQL* s, char *name,int port)
{
        char            sbuf[1000];
        const char*     proxy_host = "192.168.111.1";
        int             proxy_port = 8080;

        struct  sockaddr_in mySa,serverSa;
        struct  hostent *he;

	s->fd=socket(AF_INET,SOCK_STREAM,0);

	mySa.sin_family=AF_INET;
	mySa.sin_port=htons(0);
	mySa.sin_addr.s_addr=htonl(0);
	bind(s->fd,(struct sockaddr *)&mySa,sizeof(mySa));

	assert((he=gethostbyname(proxy_host)));
	serverSa.sin_family=AF_INET;
	serverSa.sin_port=htons(proxy_port);
	serverSa.sin_addr.s_addr=*((unsigned int*)(he->h_addr));

	assert(connect(s->fd,(struct sockaddr *)&serverSa,sizeof(serverSa))>-1);

        sprintf(sbuf, "CONNECT %s:%d HTTP/1.0\n\n", name, port);
        write(s->fd, sbuf, strlen(sbuf));

        SSL_load_error_strings();
        SSLeay_add_ss_algorithms();
        s->ssl_ctx = SSL_CTX_new(SSLv23_client_method());
        s->ssl     = SSL_new(s->ssl_ctx);
        return 0;
}

int
socket_wrapper_read(MSSQL* s, int sd, char* buf, int buflen)
{
}

int
socket_wrapper_write(MSSQL* s, int sd, char* buf, int buflen)
{
}

void dump(unsigned char *data,int len,char *comment)
{
int pos;
int i;
unsigned char dd;

	pos=0;
	printf("%s\n",comment);

	while (pos<len) {
		if (pos % 16==0)
			printf("\n%04x  ",pos);

		for (i=0;i<16;++i)
			if (i+pos < len)
				printf("%02x " ,data[pos+i]);
			else
				printf("   ");

		for (i=0;i<16;++i)
			if (i+pos < len) {
				dd=data[pos+i];
				if (!iscntrl(dd))
					printf("%c",dd);
				else
					printf(".");
			}

		pos+=16;
	}

	printf("\n\n");
	fflush(stdout);
}

#define T_C_STRING  0x01
#define T_C_INTEGER 0x02
#define T_C_DOUBLE 0x03
#define T_C_LONGLONG 0x04
#define T_C_UNDEFINED -1


#define T_VOID 0x1f
#define T_BIT 0x32
#define T_DATETIME4 0x3a
#define T_DATETIME8 0x3d
#define T_DATETIMEN 0x6f
#define T_FLOAT4 0x3b
#define T_FLOAT8 0x3e
#define T_FLOATN 0x6d
#define T_IMAGE 0x22
#define T_INT1 0x30
#define T_INT2 0x34
#define T_INT4 0x38
#define T_INTN 0x26
#define T_MONEY4 0x7a
#define T_MONEY8 0x3c
#define T_MONEYN 0x6e
#define T_DECIMAL 0x6a
#define T_NUMERIC 0x6c
#define T_TEXT 0x23
#define T_BINARY 0x2d
#define T_VARBINARY 0x25
#define T_LONGBINARY 0xe1
#define T_CHAR 0x2f
#define T_VARCHAR 0x27
#define T_LONGCHAR 0xaf
#define T_SENSITIVITY 0x67
#define T_BOUNDARY 0x68

typedef struct TYPE_DESC
{
	int type;
	char *name;
} TYPE_DESC;

TYPE_DESC types[]={
	{T_VOID, "Void"},
	{T_BINARY, "Binary"},
	{T_BIT, "Bit"},
	{T_CHAR, "Char"},
	{T_DATETIME4, "DateTime4"},
	{T_DATETIME8, "DateTime8"},
	{T_DATETIMEN, "DateTimeN"},
	{T_DECIMAL, "Decimal"},
	{T_FLOAT8, "Float8"},
	{T_FLOATN, "FloatN"},
	{T_FLOAT4, "Float4"},
	{T_IMAGE, "Image"},
	{T_INT1, "Int1"},
	{T_INT2, "Int2"},
	{T_INT4, "Int4"},
	{T_INTN, "IntN"},
	{T_LONGBINARY, "LongBinary"},
	{T_LONGCHAR, "LongChar"},
	{T_MONEY4, "Money4"},
	{T_MONEY8, "Money8"},
	{T_MONEYN, "MoneyN"},
	{T_NUMERIC, "Numeric"},
	{T_TEXT, "Text"},
	{T_VARBINARY, "VarBinary"},
	{T_VARCHAR, "VarChar"},
	{T_SENSITIVITY, "Sensitivity"},
	{T_BOUNDARY, "Boundary"},
	{0,0}
};

char *typeString(int type)
{
int i;

	for (i=0;types[i].name;++i)
		if (types[i].type==type)
			return types[i].name;
	return "N/A";
}


MSSQL *allocMsSql(void)
{
MSSQL *tmp;

	tmp=(MSSQL *) malloc(sizeof(MSSQL));
	assert(tmp);

	bzero(tmp,sizeof(MSSQL));

	tmp->fd=-1;
	tmp->blockSize=512;
	tmp->outBuf=(char *) malloc(tmp->blockSize);
	assert(tmp->outBuf);
	tmp->outPos=0;
	tmp->inBuf=(char *) malloc(tmp->blockSize);
	assert(tmp->inBuf);
	tmp->inPos=0;
	tmp->outFlag1=0x04;
	tmp->inFlag1=0;
	tmp->inState=0;
	tmp->inFragmentSize=0;

	tmp->columnCount=0;
	return tmp;
}

int connectMsSql(MSSQL *s,char *name,int port)
{
        return socket_wrapper_connect(s, name, port);
}

int setFlag(MSSQL *s,unsigned char newFlag)
{
	s->outFlag1=newFlag;
	return 0;
}

int resizeMsSql(MSSQL *s,int newSize)
{
char *newBuf;
	
	if (s->outPos>newSize)
		return -1;

	newBuf=(char *) malloc(newSize);

	assert(newBuf);
		
	memcpy(newBuf,s->outBuf,(newSize<s->blockSize?newSize:s->blockSize));
	free(s->outBuf);
	s->outBuf=newBuf;

	newBuf=(char *) malloc(newSize);

	assert(newBuf);
		
	memcpy(newBuf,s->inBuf,(newSize<s->blockSize?newSize:s->blockSize));
	free(s->inBuf);
	s->inBuf=newBuf;

	s->blockSize=newSize;
	
	return 0;
}

int writeHeader(MSSQL *s)
{
	s->outBuf[0]=s->outFlag1;
	s->outPos=8;
}

int doWrite(MSSQL *s,unsigned char lastFragment)
{
int left=s->outPos;
int n;
int pos=0;

	s->outBuf[1]=lastFragment;
	*((unsigned short*) (s->outBuf+2))=htons(s->outPos);

	while (left) {
		n=write(s->fd,s->outBuf+pos,left);
		if (n<0) {
			perror("write");
			exit(1);
		}
		left-=n;
		pos+=n;
	}

	return 0;
}

int writeBuf(MSSQL *s,char *buf,int len)
{
int pos=0;
int kaka;

	if (s->outPos==0)
		writeHeader(s);

	do {
		kaka=s->blockSize-s->outPos;
		if (len>kaka) {
			memcpy(s->outBuf+s->outPos,buf+pos,kaka);
			s->outPos+=kaka;
			pos+=kaka;
			len-=kaka;
			doWrite(s,0);
			writeHeader(s);
		} else {
			memcpy(s->outBuf+s->outPos,buf+pos,len);
			s->outPos+=len;
			break;
		}
	} while (len);

	return 0;
}

int flushMsSql(MSSQL *s)
{
	if (s->outPos>8) {
		doWrite(s,1);
		writeHeader(s);
	} else {
		fprintf(stderr,"flushMsSql: outPos<=8\n");
	}
}

int writeString(MSSQL *s,char *buf,int len)
{
char tmpBuf[len+1];
int stringLen;

	memset(tmpBuf,0,len+1);

	if (buf) {
		stringLen=strlen(buf);
		stringLen=(stringLen>len?len:stringLen);
		memcpy(tmpBuf,buf,stringLen);
		tmpBuf[len]=stringLen;
	} else
		tmpBuf[len]=0;
	
	return writeBuf(s,tmpBuf,len+1);
}

int writeChar(MSSQL *s,char data)
{
	return writeBuf(s,&data,1);
}

int writeTinyInt(MSSQL *s,int data)
{
	return writeBuf(s,(char *)&data,1);
}

int writeShortInt(MSSQL *s,short int data)
{
	return writeBuf(s,(char *)&data,2);
}

int writeLongInt(MSSQL *s,int data)
{
	return writeBuf(s,(char *)&data,4);
}

#define LAST_FRAGMENT 0x01

/*
 * Loeme sisendit
 *  s - stream
 *  buf - kuhu. ==0 --> sisendi skippimine
 *  len - kui palju
 */


int doRead(MSSQL *s,char *buf,int len)
{
int bufPos=0;

	while (len) {
		if (s->inFragmentSize==0) {
		unsigned char tmp[4];
		char *buf;
		int n;
		int left;

			if (recv(s->fd,tmp,4,MSG_PEEK)!=4) {
				perror("recv 1");
				exit(1);
			}
			s->inFlag1=tmp[0];
			s->inState=tmp[1];
			s->inFragmentSize=(unsigned int)tmp[2]<<8 | (unsigned int)tmp[3];

			assert(s->blockSize>=s->inFragmentSize);

			left=s->inFragmentSize;
			buf=s->inBuf;
			while (left) {
				n=recv(s->fd,buf,left,0);
				if (n<0) {
					perror("recv 2");
					exit(1);
				}
				left-=n;
				buf+=n;
			}

			s->inPos=8;
		}

		if (!(s->inFragmentSize-s->inPos)) {
			if (s->inState & LAST_FRAGMENT) {
				s->inState=0;
				s->inFragmentSize=0; /* valmis jrgmiseks seeriaks */
				return BUFFER_EMPTY;
			}
			s->inFragmentSize=0;
		} else if (s->inFragmentSize-s->inPos>=len) {
			if (buf)
				memcpy(buf+bufPos,s->inBuf+s->inPos,len);
			s->inPos+=len;
			return BUFFER_NOT_EMPTY;
		} else {
		/* soovime rohkem, kui puhvris leidub */
			if (s->inState & LAST_FRAGMENT) {
			/* soovime lugeda yle viimase fragmendi re! */
				return BUFFER_UNDERRUN;
			}
			if (buf)
				memcpy(buf+bufPos,s->inBuf+s->inPos,s->inFragmentSize-s->inPos);
			len-=s->inFragmentSize-s->inPos;
			bufPos+=s->inFragmentSize-s->inPos;
			s->inFragmentSize=0;
		}
	}

	return BUFFER_NOT_EMPTY;
}

int readChar(MSSQL *s,char *data)
{
	return doRead(s,data,1);
}

int readTinyInt(MSSQL *s,int *data)
{
	*data=0;
	return doRead(s,(char *)data,1);
}

int readShortInt(MSSQL *s,int *data)
{
	*data=0;
	return doRead(s,(char *)data,2);
}

int readLongInt(MSSQL *s,int *data)
{
	return doRead(s,(char *)data,4);
}

int readNInt(MSSQL *s,int *data,int len)
{
	switch (len) {
	case 0:
		*data=0;
		break;
	case 1:
		*data=0;
		return doRead(s,(char *) data,1);
	case 2:
		*data=0;
		return doRead(s,(char *) data,2);
	case 4:
		return doRead(s,(char *) data,4);
	default:
		fprintf(stderr,"Bloody bad integer length!!!");
		exit(1);
	}

	return 0;
}

int readSmallString(MSSQL *s,char *buf,int max)
{
int len;
int rc;

	rc=readTinyInt(s,&len);
	if (len>max) {
		doRead(s,buf,max);
		if (buf)
			buf[max]=0;
		rc|=doRead(s,0,len-max);
	} else {
		rc|=doRead(s,buf,len);
		if (buf)
			buf[len]=0;
	}
	return rc;
}

int readMediumString(MSSQL *s,char *buf,int max)
{
int len;
int rc;

	readShortInt(s,&len);
	if (len>max) {
		doRead(s,buf,max);
		if (buf)
			buf[max]=0;
		rc=doRead(s,0,len-max);
	} else {
		rc=doRead(s,buf,len);
		if (buf)
			buf[len]=0;
	}
	return rc;
}

int readLargeString(MSSQL *s,char *buf,int max)
{
int len;
int rc;

	rc=readLongInt(s,&len);
	if (len>max) {
		doRead(s,buf,max);
		if (buf)
			buf[max]=0;
		rc=doRead(s,0,len-max);
	} else {
		rc=doRead(s,buf,len);
		if (buf)
			buf[len]=0;
	}
	return rc;
}

int read4Float(MSSQL *s,double *buf)
{
float tmp;
int rc;

	rc=doRead(s,(char *)&tmp,4);
	if (buf)
		*buf=tmp;
	return rc;
}

int read8Float(MSSQL *s,double *buf)
{
	return doRead(s,(char *)buf,8);
}


int read8Money(MSSQL *s,long long *buf)
{
char tmp[8];
int rc;

	rc=doRead(s,tmp,8);
	if (buf) {
		memcpy((char*)buf,tmp+4,4);
		memcpy((char*)buf+4,tmp,4);
	}
	return rc;
}

int read4Money(MSSQL *s,long long *buf)
{
int tmp;
int rc;

	rc=readLongInt(s,&tmp);
	if (buf)
		*buf=tmp;
	return rc;
}

int readNumeric(MSSQL *s,double *buf)
{
int len;
int rc;

	rc=readTinyInt(s,&len);
	rc=doRead(s,0,len);
	return rc;
}

int doLogin(MSSQL *s,
  char *hostName,
  char *userName,
  char *password,
  char *id,
  char *appName,
  char *serviceName,
  char *language,
  char *charset
  )
{
/*char magic1[]= {0x02,0x00,0x04,0x06,0x08,0x01,0x01,0x00,0x00};*/
/*char magic1[]= {0x03,0x01,0x06,0x0a,0x09,0x01,0x01,0x00,0x00};*/
char magic1[]=   {0x03,0x01,0x06,0x0a,0x09,0x01,0x01,0x00,0x00};
char magic2[]= {0x00,0x00,0x00};
char protocolVersion[]= {0x04,0x02,0x00,0x00};
char magic3[]= {0x00,13,17};
char magic4[]= {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
char magic5=   0x01;

	writeString(s,hostName,30);
	writeString(s,userName,30);
	writeString(s,password,30);
	writeString(s,id,30);
	writeBuf(s,magic1,9);
	writeLongInt(s,512);
	writeBuf(s,magic2,3);
	writeString(s,appName,30);
	writeString(s,serviceName,30);
	writeString(s,password,255);
	writeBuf(s,protocolVersion,4);
	writeString(s,"Pecioma",10);
	writeLongInt(s,1);
	writeBuf(s,magic3,3);
	writeString(s,language,30);
	writeBuf(s,magic4,14);
	writeString(s,charset,30);
	writeChar(s,magic5);
	writeString(s,"4096",6);
	writeLongInt(s,0);
	writeLongInt(s,0);
	flushMsSql(s);
}

int handleColumnNames(MSSQL *s)
{
int column=0;
int len;
int rc;

	rc=readShortInt(s,&len);

	while (len) {
		if (rc&BUFFER_UNDERRUN)
			return BUFFER_UNDERRUN;
		if (rc&BUFFER_EMPTY)
			return BUFFER_EMPTY;

		rc|=readSmallString(s,s->columns[column].name,32);
		len-=strlen(s->columns[column].name)+1;
		printf("%s\n",s->columns[column].name);
		column++;
	}
}

handleMetaData(MSSQL *s)
{
int len;
int column=0;
int rc;

	rc=readShortInt(s,&len);

	while (len) {
		if (rc&BUFFER_UNDERRUN)
			return BUFFER_UNDERRUN;
		if (rc&BUFFER_EMPTY)
			return BUFFER_EMPTY;

		rc|=readLongInt(s,&(s->columns[column].flags));
		rc|=readTinyInt(s,&(s->columns[column].type));
		len-=5;

		switch (s->columns[column].type) {
		case T_INT1:
		case T_BIT:
			s->columns[column].len=1;
			break;
		case T_INT2:
			s->columns[column].len=2;
			break;
		case T_INT4:
		case T_DATETIME4:
		case T_FLOAT4:
		case T_MONEY4:
			s->columns[column].len=4;
			break;
		case T_MONEY8:
		case T_DATETIME8:
		case T_FLOAT8:
			s->columns[column].len=8;
			break;
		case T_VARBINARY:
		case T_INTN:
		case T_VARCHAR:
		case T_BINARY:
		case T_CHAR:
		case T_SENSITIVITY:
		case T_BOUNDARY:
		case T_FLOATN:
		case T_MONEYN:
		case T_DATETIMEN:
			rc|=readTinyInt(s,&(s->columns[column].len));
			len--;
			break;
		case T_DECIMAL:
		case T_NUMERIC:
			rc|=readTinyInt(s,&(s->columns[column].len));
			rc|=readTinyInt(s,&(s->columns[column].precision));
			rc|=readTinyInt(s,&(s->columns[column].scale));
			len-=3;
			break;
		case T_LONGCHAR:
		case T_LONGBINARY:
			rc|=readLongInt(s,&(s->columns[column].len));
			len-=4;
			break;
		case T_IMAGE:
		case T_TEXT:
			rc|=readLongInt(s,&(s->columns[column].len));
			rc|=readMediumString(s,s->columns[column].tableName,32);
			len-=4+strlen(s->columns[column].tableName);
			break;
		default:
			fprintf(stderr,"Data type %02x not supported!\n",				
			  s->columns[column].type);
			exit(1);
		}
		column++;
	}
	s->columnCount=column;

	return rc;
}

int toCType(int dbType)
{
	switch (dbType) {
	case T_INT1:
	case T_BIT:
	case T_INT2:
	case T_INT4:
	case T_INTN:
		return T_C_INTEGER;
	case T_FLOAT4:
	case T_FLOAT8:
	case T_FLOATN:
		return T_C_DOUBLE;
	case T_MONEY4:
	case T_MONEY8:
	case T_MONEYN:
		return T_C_LONGLONG;
	case T_VARBINARY:
	case T_VARCHAR:
	case T_BINARY:
	case T_CHAR:
		return T_C_STRING;
	case T_SENSITIVITY:
	case T_BOUNDARY:
	case T_DECIMAL:
	case T_NUMERIC:
	case T_LONGCHAR:
	case T_LONGBINARY:
	case T_IMAGE:
	case T_TEXT:
	case T_DATETIME4:
	case T_DATETIME8:
	case T_DATETIMEN:
		return T_C_UNDEFINED;
	default:
		fprintf(stderr,"toCType: Unknown data type %02x.\n",dbType);
		return 0;
	}
}

int handleRowData(MSSQL *s)
{
int i;
int rc;
void *val;
int maxlen;
int len;
int dbType;

	for (i=0,rc=0;i<s->columnCount;++i) {
		if (rc&BUFFER_UNDERRUN)
			return BUFFER_UNDERRUN;
		if (rc&BUFFER_EMPTY)
			return BUFFER_EMPTY;

		rc=0;
		val=s->columns[i].val;
		maxlen=s->columns[i].maxlen;
		dbType=s->columns[i].type;

		if (val && (toCType(dbType)==T_C_UNDEFINED || toCType(dbType)!=s->columns[i].boundType)) {
			fprintf(stderr,"C type mismatch at column %d.\n",i);
			val=0;
		}
		
		switch (dbType) {
		case T_INT1:
		case T_BIT:
			rc|=readTinyInt(s,val);
			break;
		case T_INT2:
			rc|=readShortInt(s,val);
			break;
		case T_INT4:
			rc|=readLongInt(s,val);
			break;
		case T_INTN:
			rc|=readTinyInt(s,&len);
			switch (len) {
			case 0:
				if (val)
					*((int*)val)=0;
				break;
			case 1:
				rc|=readTinyInt(s,(int*) val);
				break;
			case 2:
				rc|=readShortInt(s,(int*) val);
				break;
			case 4:
				rc|=readLongInt(s,(int*) val);
				break;
			default:
				fprintf(stderr,"INTN: Illegal length=%d\n",len);
				break;
			}
			break;
		case T_FLOAT4:
			rc|=read4Float(s,(double *) val);
			break;
		case T_FLOAT8:
			rc|=read8Float(s,(double *) val);
			break;
		case T_FLOATN:
			rc|=readTinyInt(s,&len);
			switch (len) {
			case 0:
				if (val)
					*((double *) val)=0.0;
				break;
			case 4:
				rc|=read4Float(s,(double *) val);
				break;
			case 8:
				rc|=read8Float(s,(double *) val);
				break;
			default:
				fprintf(stderr,"FLOATN: Illegal length=%d\n",len);
				break;
			}
			break;
		case T_MONEY4:
			rc|=read4Money(s,(long long *) val);
			break;
		case T_MONEY8:
			rc|=read8Money(s,(long long *) val);
			break;
		case T_MONEYN:
			rc|=readTinyInt(s,&len);
			switch (len) {
			case 0:
				if (val)
					*((long long *) val)=0;
				break;
			case 4:
				rc|=read4Money(s,(long long *) val);
				break;
			case 8:
				rc|=read8Money(s,(long long *) val);
				break;
			default:
				fprintf(stderr,"MONEYN: Illegal length=%d\n",len);
				break;
			}
			break;
		case T_DATETIME4:
			rc|=doRead(s,0,4);
			break;
		case T_DATETIME8:
			rc|=doRead(s,0,8);
			break;
		case T_DATETIMEN:
			rc|=readTinyInt(s,&len);
			switch (len) {
			case 0:
				break;
			case 4:
				rc|=doRead(s,0,4);
				break;
			case 8:
				rc|=doRead(s,0,8);
				break;
			default:
				fprintf(stderr,"DATETIMEN: Illegal length=%d\n",len);
				break;
			}
			break;
		case T_VARBINARY:
		case T_VARCHAR:
		case T_BINARY:
		case T_CHAR:
			rc|=readSmallString(s,(char *) val,maxlen);
			break;
		case T_SENSITIVITY:
			fprintf(stderr,"SENSITIVITY: not supported!\n");
			break;
		case T_BOUNDARY:
			fprintf(stderr,"BOUNDARY: not supported!\n");
			break;
		case T_DECIMAL:
		case T_NUMERIC:
			rc|=readTinyInt(s,&len);
			rc|=doRead(s,0,len);        /* SIC!!! */
			break;
		case T_LONGCHAR:
		case T_LONGBINARY:
			fprintf(stderr,"LONGCHAR | LONGBINARY: not supported!\n");
			break;
		case T_IMAGE:
		case T_TEXT:
			fprintf(stderr,"IMAGE | TEXT: not supported!\n");
			break;
		default:
			fprintf(stderr,"Data type %02x not supported!\n",				
			  s->columns[i].type);
			exit(1);
		}
	}

	return rc;
}

int checkColumnIndex(MSSQL *s,int column)
{
	if (column<0||column>255) {
		strcpy(s->lastError,"bindIntegerColumn: illegal column index.");
		return 1;
	}
	return 0;
}

int bindIntegerColumn(MSSQL *s,int column,int *buf)
{
	if (checkColumnIndex(s,column))
		return 1;

	s->columns[column].val=(void*) buf;
	s->columns[column].boundType=T_C_INTEGER;

	return 0;
}

int bindLonglongColumn(MSSQL *s,int column,long long *buf)
{
	if (checkColumnIndex(s,column))
		return 1;

	s->columns[column].val=(void*) buf;
	s->columns[column].boundType=T_C_LONGLONG;

	return 0;
}

int bindStringColumn(MSSQL *s,int column,char *buf,int maxlen)
{
	if (checkColumnIndex(s,column))
		return 1;

	s->columns[column].val=(void*) buf;
	s->columns[column].maxlen=maxlen;
	s->columns[column].boundType=T_C_STRING;

	return 0;
}

int bindDoubleColumn(MSSQL *s,int column,double *buf)
{
	if (checkColumnIndex(s,column))
		return 1;

	s->columns[column].val=(void*) buf;
	s->columns[column].boundType=T_C_DOUBLE;

	return 0;
}

#define TOKEN_COL_NAMES 0xa0
#define TOKEN_COL_METADATA 0xa1
#define TOKEN_ROW_DATA 0xd1
#define TOKEN_ENV_CHANGE 0xe3
#define TOKEN_LOGIN_ACK 0xad
#define TOKEN_INFO 0xab
#define TOKEN_DONE1 0xfd
#define TOKEN_DONE2 0xfe
#define TOKEN_DONE3 0xff
#define TOKEN_ERROR 0xaa

int handleToken(MSSQL *s,int token)
{
int len;
int rc;

/*
	printf("token=%02x\n",token);
*/
	switch (token) {
	case TOKEN_COL_NAMES:
		rc=handleColumnNames(s);
		break;
	case TOKEN_COL_METADATA:
		rc=handleMetaData(s);
		break;
	case TOKEN_ENV_CHANGE:
	{
	char buf1[4096];
	char buf2[4096];
	int type;
	
		rc=readShortInt(s,&len);
		rc|=readTinyInt(s,&type);
		fprintf(stderr,"Environment change: %02x: ",type);
		switch (type) {
		case 0x01:
			rc|=readSmallString(s,buf1,4095);
			rc|=readSmallString(s,buf2,4095);
			fprintf(stderr," current database: %s->%s\n",
			  buf2,buf1);
			break;
		case 0x04:
			rc|=readSmallString(s,buf1,4095);
			rc|=readSmallString(s,buf2,4095);
			fprintf(stderr," network packet: %s->%s\n",
			  buf2,buf1);
			break;
		default:
			doRead(s,buf1,len-1);
			dump(buf1,len-1,"");
			break;
		}
		break;
	}
	case TOKEN_LOGIN_ACK:
	{
	char buf[4096];
	int status;
	char protoVersion[4];
	char progName[33];
	char progVersion[4];
	
		rc=readShortInt(s,&len);
		rc|=readTinyInt(s,&status);
		rc|=doRead(s,protoVersion,4);
		rc|=readSmallString(s,progName,32);
		rc|=doRead(s,progVersion,4);
		
		fprintf(stderr,"Login ACK: status: %d, program name: %s\n",
		  status,progName);
		break;
	}
	case TOKEN_INFO:
	{
	char buf[33];
	
		rc=readShortInt(s,&len);
		rc|=doRead(s,0,6);
		rc|=readMediumString(s,buf,32);
		rc|=readSmallString(s,0,1);
		rc|=doRead(s,0,3);
		printf("Info: %s\n",buf);
		break;
	}
	case TOKEN_ERROR:
	{
	char buf[33];
	
		rc=readShortInt(s,&len);
		rc|=doRead(s,0,6);
		rc|=readMediumString(s,buf,32);
		rc|=readSmallString(s,0,1);
		rc|=doRead(s,0,3);
		printf("Error: %s\n",buf);
		break;
	}
	case TOKEN_DONE1:
	case TOKEN_DONE2:
	case TOKEN_DONE3:
	{
	int status1;
	int status2;
	int count;
	
		rc=readShortInt(s,&status1);
		rc|=readShortInt(s,&status2);
		rc|=readLongInt(s,&count);
		fprintf(stderr,"Done: status1=%d,status2=%d,count=%d\n",
		  status1,status2,count);
		break;
	}
	case TOKEN_ROW_DATA:
		rc=handleRowData(s);
		break;
	}

	return rc;
}

	
int execDirect(MSSQL *s,char *query)
{
int rc;
int token;

	writeBuf(s,query,strlen(query));
	flushMsSql(s);
	
	s->queryState=WAITING_ROW;

	while (s->queryState!=ROW_READY && 
	  (rc=readTinyInt(s,&token))==BUFFER_NOT_EMPTY) {
		if (handleToken(s,token)==BUFFER_UNDERRUN)
			break;
		switch (token) {
		case TOKEN_ROW_DATA:
			s->queryState=ROW_READY;
			break;
		case TOKEN_DONE1:
		case TOKEN_DONE2:
		case TOKEN_DONE3:
			s->queryState=DONE;
			break;
		}
	}

	return s->queryState;
}

int nextTuple(MSSQL *s)
{
int rc;
int token;

	if (s->queryState!=ROW_READY)
		return DONE;

	s->queryState=WAITING_ROW;

	while (s->queryState!=ROW_READY && 
	  (rc=readTinyInt(s,&token))==BUFFER_NOT_EMPTY) {
		if (handleToken(s,token)==BUFFER_UNDERRUN)
			break;
		switch (token) {
		case TOKEN_ROW_DATA:
			s->queryState=ROW_READY;
			break;
		case TOKEN_DONE1:
		case TOKEN_DONE2:
		case TOKEN_DONE3:
			s->queryState=DONE;
			break;
		}
	}

	return s->queryState;
}

/*
    1. allocMsSql()
    2. connectMsSql()
    3. doLogin()
    4. resizeMsSql() - 
    5. setFlag()
    6. n korda bindXXXColumn()
    7. execDirect()             - NB! fetchib v@imaluse korral juba esimese rea!
    8. fetchTuple()

  Nagu n#ha, on see saadana API jumala sassis. #ra ainult muretse, varsti taon 
  viisakamaks ringi! Kuid vastu tulles rahva soovidele avalikustan selle
  pasatyki...

  Hetkel tunnistab kutt char(x), varchar(x), *int, real, ja *money-tyypi.
  Konvertimine C tyypideks on hardcoded:
  	*CHAR* - char[n]
  	*int   - int
  	real   - double
  	*money - long long, skaleeritud (vist) 10000 yles.
  Kui binditud andmetyyp ei sobi, siis kutt vigiseb kergelt kuid kytab kylma
  k6huga edasi.
*/

test_mssql_main(int argc,char *argv[])
{
MSSQL *s;
int token;
int rc;
int state;

int a;
double b;
char c[33];
long long d;

char *q=
  "select 1 as a,"
  "convert(real,10.0) as b,"
  "'kala' as c,"
  "convert(money,399.4) as d";

	s=allocMsSql();
	connectMsSql(s,"192.168.11.130",1433);

	doLogin(s,
	  "klientmasina nimi",
	  "nimi",
	  "parool",
	  "00112233",             /* suva hex-string */
	  "fakk","sakk",
	  "us_english","iso_1");

	while ((rc=readTinyInt(s,&token))==BUFFER_NOT_EMPTY) {
		if ((rc=handleToken(s,token))==BUFFER_UNDERRUN) {
			fprintf(stderr,"ARRGGHHH!!!\n");
			exit(1);
		}
	}

printf("ready...\n");

	resizeMsSql(s,4096);    /* on vaja! */
	setFlag(s,1);            /* on vaja! */

	bindIntegerColumn(s,0,&a);
	bindDoubleColumn(s,1,&b);
	bindStringColumn(s,2,c,32); /* tagastatava stringi max. pikkus v6ib
					olla baasi omast lyhem! */
	bindLonglongColumn(s,3,&d);

	for (state=execDirect(s,q);
	  state==ROW_READY;
	  state=nextTuple(s))
		printf("%d,%f,'%s',%Ld\n",a,b,c,d);
}

