/*
 * Haruldaselt rudimentaarne MSSQL ja Sybase klient. Pritsib
 * protokolli TDS ver. 4.2.
 *
 * Mina (st. Arno) pole milleski syydi, mis ka ei juhtuks!!!!!
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>
#include <netinet/in.h> /* for htons */
#include <time.h>

#include "tds.h"
#include "mssql.h"

#define T_C_STRING  0x01
#define T_C_INTEGER 0x02
#define T_C_DOUBLE 0x03
#define T_C_LONGLONG 0x04
#define T_C_UNDEFINED -1

TYPE_DESC types[]={
	{T_VOID, "Void"},
	{T_BINARY, "Binary"},
	{T_BIT, "Bit"},
	{T_CHAR, "Char"},
	{T_DATETIME4, "DateTime4"},
	{T_DATETIME8, "DateTime8"},
	{T_DATETIMEN, "DateTimeN"},
	{T_DECIMAL, "Decimal"},
	{T_FLOAT8, "Float8"},
	{T_FLOATN, "FloatN"},
	{T_FLOAT4, "Float4"},
	{T_IMAGE, "Image"},
	{T_INT1, "Int1"},
	{T_INT2, "Int2"},
	{T_INT4, "Int4"},
	{T_INTN, "IntN"},
	{T_LONGBINARY, "LongBinary"},
	{T_LONGCHAR, "LongChar"},
	{T_MONEY4, "Money4"},
	{T_MONEY8, "Money8"},
	{T_MONEYN, "MoneyN"},
	{T_NUMERIC, "Numeric"},
	{T_TEXT, "Text"},
	{T_VARBINARY, "VarBinary"},
	{T_VARCHAR, "VarChar"},
	{T_SENSITIVITY, "Sensitivity"},
	{T_BOUNDARY, "Boundary"},
	{0,0}
};

char *
typeString(int type)
{
int i;

	for (i=0;types[i].name;++i)
		if (types[i].type==type)
			return types[i].name;
	return "N/A";
}

MSSQL *
allocMsSql(void)
{
MSSQL *tmp;

	tmp=(MSSQL *) malloc(sizeof(MSSQL));
	assert(tmp);

	bzero(tmp,sizeof(MSSQL));

	tmp->fd=-1;
	tmp->blockSize=512;
	tmp->outBuf=(unsigned char *) malloc(tmp->blockSize);
	assert(tmp->outBuf);
	tmp->outPos=0;
	tmp->inBuf=(unsigned char *) malloc(tmp->blockSize);
	assert(tmp->inBuf);
	tmp->inPos=0;
	tmp->outFlag1=0x04;
	tmp->inFlag1=0;
	tmp->inState=0;
	tmp->inFragmentSize=0;

	tmp->columnCount=0;

	tmp->connect=0;
	tmp->disconnect=0;
	tmp->read=0;
	tmp->write=0;

	return tmp;
}

int
connectMsSql(MSSQL *s,char *name,int port)
{
	return s->connect(s,name,port);
}

int
disconnectMsSql(MSSQL *s)
{
	return s->disconnect(s);
}

int
setFlag(MSSQL *s,unsigned char newFlag)
{
	s->outFlag1=newFlag;
	return 0;
}

int
resizeMsSql(MSSQL *s,int newSize)
{
char *newBuf;
	
	if (s->outPos>newSize)
		return -1;

	newBuf=(char *) malloc(newSize);

	assert(newBuf);
		
	memcpy(newBuf,s->outBuf,(newSize<s->blockSize?newSize:s->blockSize));
	free(s->outBuf);
	s->outBuf=(unsigned char*)newBuf;

	newBuf=(char *) malloc(newSize);

	assert(newBuf);
		
	memcpy(newBuf,s->inBuf,(newSize<s->blockSize?newSize:s->blockSize));
	free(s->inBuf);
	s->inBuf=(unsigned char*)newBuf;

	s->blockSize=newSize;
	
	return 0;
}

/*
 * Writers
 *
 */

void
writeHeader(MSSQL *s)
{
	s->outBuf[0]=s->outFlag1;
	s->outPos=8;
}

int
doWrite(MSSQL *s,unsigned char lastFragment)
{
	s->outBuf[1]=lastFragment;
	*((unsigned short*) (s->outBuf+2))=htons(s->outPos);

	return s->write(s,s->outBuf,s->outPos);
}

int
writeBuf(MSSQL *s,unsigned char *buf,int len)
{
int pos=0;
int kaka;

	if (s->outPos==0)
		writeHeader(s);

	do {
		kaka=s->blockSize-s->outPos;
		if (len>kaka) {
			memcpy(s->outBuf+s->outPos,buf+pos,kaka);
			s->outPos+=kaka;
			pos+=kaka;
			len-=kaka;
			doWrite(s,0);
			writeHeader(s);
		} else {
			memcpy(s->outBuf+s->outPos,buf+pos,len);
			s->outPos+=len;
			break;
		}
	} while (len);

	return 0;
}

int
writeString(MSSQL *s,char *buf,int len)
{
char tmpBuf[len+1];
int stringLen;

	memset(tmpBuf,0,len+1);

	if (buf) {
		stringLen=strlen(buf);
		stringLen=(stringLen>len?len:stringLen);
		memcpy(tmpBuf,buf,stringLen);
		tmpBuf[len]=stringLen;
	} else
		tmpBuf[len]=0;
	
	return writeBuf(s,(unsigned char *)tmpBuf,len+1);
}

/*
 * See pask pole sugugi mitte portaabel!!!!
 * K#ntsab muu hulgas 64bit purgis...
 */
int
writeChar(MSSQL *s,unsigned char data)
{
	return writeBuf(s,&data,1);
}

int
write1Int(MSSQL *s,int data)
{
unsigned char buf;

	buf=data;
	return writeBuf(s,(unsigned char *)&buf,1);
}

int
write2Int(MSSQL *s,int data)
{
short int tmpData;

	tmpData=data;
	return writeBuf(s,(unsigned char *)&tmpData,2);
}

int
write4Int(MSSQL *s,int data)
{
	return writeBuf(s,(unsigned char *) &data,4);
}

int
flushMsSql(MSSQL *s)
{
int rc=0;

	if (s->outPos>8) {
		rc=doWrite(s,1);
		writeHeader(s);
	} else {
		/* Persekellad */
	}
	return rc;
}

/*
 * Readers
 *
 */

#define LAST_FRAGMENT 0x01

int
doRead(MSSQL *s,unsigned char *buf,int len)
{
int bufPos=0;

	while (len) {
		if (s->inFragmentSize==0) {
			if (s->read(s,s->inBuf,4)) {
fprintf(stderr,"s->read() 1\n");
exit(1);
			}

			s->inFlag1=s->inBuf[0];
			s->inState=s->inBuf[1];
			s->inFragmentSize=(unsigned int)s->inBuf[2]<<8 |
			  (unsigned int)s->inBuf[3];

			if (s->blockSize<s->inFragmentSize) {
fprintf(stderr,"blockSize<fragmentSize\n");
exit(1);
			}

			if (s->read(s,s->inBuf+4,s->inFragmentSize-4)) {
fprintf(stderr,"s->read() 2\n");
exit(1);
			}
			s->inPos=8;
/*
dump(s->inBuf,s->inFragmentSize,"");
*/
		}

		if (!(s->inFragmentSize-s->inPos)) {
			if (s->inState & LAST_FRAGMENT) {
				s->inState=0;
				s->inFragmentSize=0; /* valmis jrgmiseks seeriaks */
				return BUFFER_EMPTY;
			}
			s->inFragmentSize=0;
		} else if (s->inFragmentSize-s->inPos>=len) {
			if (buf)
				memcpy(buf+bufPos,s->inBuf+s->inPos,len);
			s->inPos+=len;
			return BUFFER_NOT_EMPTY;
		} else {
		/* soovime rohkem, kui puhvris leidub */
			if (s->inState & LAST_FRAGMENT) {
			/* soovime lugeda yle viimase fragmendi re! */
				return BUFFER_UNDERRUN;
			}
			if (buf)
				memcpy(buf+bufPos,s->inBuf+s->inPos,s->inFragmentSize-s->inPos);
			len-=s->inFragmentSize-s->inPos;
			bufPos+=s->inFragmentSize-s->inPos;
			s->inFragmentSize=0;
		}
	}

	return BUFFER_NOT_EMPTY;
}

int
read1Int(MSSQL *s,int *data)
{
unsigned char buf;
int rc;

	rc=doRead(s,&buf,1);
	if (data)
		*data=buf;
	return rc;
}

int
read2Int(MSSQL *s,int *data)
{
short int tmpData;
int rc;

	rc=doRead(s,(unsigned char *)&tmpData,2);
	if (data)
		*data=(short int)tmpData;

	return rc;
}

int
read2UInt(MSSQL *s,int *data)
{
short unsigned int tmpData;
int rc;

	rc=doRead(s,(unsigned char *)&tmpData,2);
	if (data)
		*data=(int)tmpData;

	return rc;
}

int
read4Int(MSSQL *s,int *data)
{
int tmpData;
int rc;

	rc=doRead(s,(unsigned char *)&tmpData,4);
	if (data)
		*data=(int)tmpData;

	return rc;
}

int
readNInt(MSSQL *s,int *data)
{
int len;
int rc;

	rc=read1Int(s,&len);

	switch (len) {
	case 0:
		if (data)
			*data=0;
		break;
	case 1:
		rc|=read1Int(s,data);
		break;
	case 2:
		rc|=read2Int(s,data);
		break;
	case 4:
		rc|=read4Int(s,data);
		break;
	default:
		/*
			persekellad!
		*/
		break;
	}

	return rc;
}

int
readSmallString(MSSQL *s,char *buf,int max)
{
int len;
int rc;

	rc=read1Int(s,&len);

	if (len>=max) {
		rc|=doRead(s,(unsigned char *)buf,max);
		if (buf)
			buf[max]=0;
		rc|=doRead(s,0,len-max);
	} else {
		rc|=doRead(s,(unsigned char *)buf,len);
		if (buf)
			buf[len]=0;
	}
	return rc;
}

int
readMediumString(MSSQL *s,char *buf,int max)
{
int len;
int rc;

	rc=read2UInt(s,&len);

	if (len>=max) {
		rc|=doRead(s,(unsigned char *)buf,max);
		if (buf)
			buf[max]=0;
		rc|=doRead(s,0,len-max);
	} else {
		rc|=doRead(s,(unsigned char *)buf,len);
		if (buf)
			buf[len]=0;
	}
	return rc;
}

int
readLargeString(MSSQL *s,char *buf,int max)
{
int len;
int rc;

	rc=read4Int(s,&len);

	if (len>=max) {
		rc|=doRead(s,(unsigned char *)buf,max);
		if (buf)
			buf[max]=0;
		rc|=doRead(s,0,len-max);
	} else {
		rc|=doRead(s,(unsigned char *)buf,len);
		if (buf)
			buf[len]=0;
	}
	return rc;
}

int
read4Float(MSSQL *s,double *buf)
{
float tmp;
int rc;

	rc=doRead(s,(unsigned char *)&tmp,4);
	if (buf)
		*buf=tmp;
	return rc;
}

int
read8Float(MSSQL *s,double *buf)
{
	return doRead(s,(unsigned char *)buf,8);
}

int
readNFloat(MSSQL *s,double *buf)
{
int len;
int rc;

	rc=read1Int(s,&len);

	switch (len) {
	case 0:
		if (buf)
			*buf=0.0;
		break;
	case 4:
		rc|=read4Float(s,buf);
		break;
	case 8:
		rc|=read8Float(s,buf);
		break;
	default:
		/*
			persekellad!
		*/
		break;
	}
	return rc;
}

int
read8Money(MSSQL *s,long long *buf)
{
#if defined(HW_LITTLE_ENDIAN)
unsigned char tmp[8];
int rc;

	rc=doRead(s,tmp,8);

	if (buf) {
		*(unsigned long long*)buf=
		  (unsigned long long)tmp[0]<<(4*8) |
		  (unsigned long long)tmp[1]<<(5*8) |
		  (unsigned long long)tmp[2]<<(6*8) |
		  (unsigned long long)tmp[3]<<(7*8) |
		  (unsigned long long)tmp[4] |
		  (unsigned long long)tmp[5]<<8 |
		  (unsigned long long)tmp[6]<<(2*8) |
		  (unsigned long long)tmp[7]<<(3*8);
	}
#elif defined(HW_BIG_ENDIAN)
int rc;

	rc=doRead(s,(unsigned char *) buf,8);
#else
#error Blaah!
#endif

	return rc;
}

int
read4Money(MSSQL *s,long long *buf)
{
int tmp;
int rc;

	rc=doRead(s,(unsigned char *)&tmp,4);

	if (buf)
		*buf=tmp;
	
	return rc;
}

int
readNMoney(MSSQL *s,long long *buf)
{
int len;
int rc;

	rc=read1Int(s,&len);

	switch (len) {
	case 0:
		if (buf)
			*buf=0;
		break;
	case 4:
		rc|=read4Money(s,buf);
		break;
	case 8:
		rc|=read8Money(s,buf);
		break;
	default:
		/*
			persekellad
		*/
		break;
	}
	return rc;
}

int
readNumeric(MSSQL *s,double *buf)
{
int len;
int rc;
unsigned char tmp[64];

	rc=read1Int(s,&len);
	rc|=doRead(s,tmp,len);
	dump((char *)tmp,len,"");
	return rc;
}

#define MSSQL_EPOCH 25567 /* 1900 --pevi--> 1970 */
#define SECONDS_PER_DAY 24*60*60

int
read4Datetime(MSSQL *s,time_t *buf)
{
int rc;
unsigned int days;
unsigned int minutes;
time_t aaa;

	rc=read2UInt(s,&days);
	rc|=read2UInt(s,&minutes);
	if (buf)
		*buf=(days-MSSQL_EPOCH)*SECONDS_PER_DAY+minutes*60;

	aaa=(days-MSSQL_EPOCH)*SECONDS_PER_DAY+minutes*60;
	printf("datetime4 %s",ctime(&aaa));

	return rc;
}

int
read8Datetime(MSSQL *s,time_t *buf)
{
int rc;
int days;
int seconds;
time_t aaa;
struct tm *t;

	rc=read4Int(s,&days);
	rc=read4Int(s,&seconds);
	if (buf)
		*buf=(days-MSSQL_EPOCH)*SECONDS_PER_DAY+seconds/300;

	aaa=(days-MSSQL_EPOCH)*SECONDS_PER_DAY+seconds/300;
	t=gmtime(&aaa);
	
	printf("datetime8 %04d%02d%02d%02d%02d%02d\n",
	  t->tm_year+1900,
	  t->tm_mon+1,
	  t->tm_mday,
	  t->tm_hour,
	  t->tm_min,
	  t->tm_sec);

	return rc;
}

int
readNDatetime(MSSQL *s,time_t *buf)
{
int len;
int rc;

	rc|=read1Int(s,&len);
	switch (len) {
	case 0:
		break;
	case 4:
		rc|=read4Datetime(s,buf);
		break;
	case 8:
		rc|=read8Datetime(s,buf);
		break;
	default:
		fprintf(stderr,"DATETIMEN: Illegal length=%d\n",len);
		break;
	}

	return rc;
}

void
freeMetaData(MSSQL *s)
{
COLUMN *c,*next;

	for (c=s->columns.next;c;c=next) {
		next=c->next;
		free(c);
	}

	s->columns.next=0;
	s->columnCount=0;
}

int
handleColumnNames(MSSQL *s)
{
int len;
int rc;
COLUMN *c;

	rc=read2Int(s,&len);

	freeMetaData(s);
	c=&(s->columns);

	while (len) {
		if (rc&BUFFER_UNDERRUN)
			return BUFFER_UNDERRUN;
		if (rc&BUFFER_EMPTY)
			return BUFFER_EMPTY;

		c->next=(COLUMN *)malloc(sizeof(COLUMN));
		bzero(c->next,sizeof(COLUMN));
		
		rc|=readSmallString(s,c->next->name,32);
		len-=strlen(c->next->name)+1;
		printf("%s\n",c->next->name);
		s->columnCount++;

		c=c->next;
	}

	return rc;
}

int
handleMetaData(MSSQL *s)
{
int len;
int rc;
COLUMN *c;

	rc=read2Int(s,&len);
	c=s->columns.next;

	while (len) {
		if (c==0) {
			/* nimede ning metadata kogus ei klapi! */
			exit(1);
		}
		if (rc&BUFFER_UNDERRUN)
			return BUFFER_UNDERRUN;
		if (rc&BUFFER_EMPTY)
			return BUFFER_EMPTY;

		rc|=read4Int(s,(int *)&(c->flags));
		rc|=read1Int(s,&(c->type));
		len-=5;

		switch (c->type) {
		case T_INT1:
		case T_BIT:
			c->len=1;
			break;
		case T_INT2:
			c->len=2;
			break;
		case T_INT4:
		case T_DATETIME4:
		case T_FLOAT4:
		case T_MONEY4:
			c->len=4;
			break;
		case T_MONEY8:
		case T_DATETIME8:
		case T_FLOAT8:
			c->len=8;
			break;
		case T_VARBINARY:
		case T_INTN:
		case T_VARCHAR:
		case T_BINARY:
		case T_CHAR:
		case T_SENSITIVITY:
		case T_BOUNDARY:
		case T_FLOATN:
		case T_MONEYN:
		case T_DATETIMEN:
			rc|=read1Int(s,&(c->len));
			len--;
			break;
		case T_DECIMAL:
		case T_NUMERIC:
			rc|=read1Int(s,&(c->len));
			rc|=read1Int(s,&(c->precision));
			rc|=read1Int(s,&(c->scale));
			len-=3;
			break;
		case T_LONGCHAR:
		case T_LONGBINARY:
			rc|=read4Int(s,&(c->len));
			len-=4;
			break;
		case T_IMAGE:
		case T_TEXT:
			rc|=read4Int(s,&(c->len));
			rc|=readMediumString(s,c->tableName,32);
			len-=4+strlen(c->tableName); /* AIAIAI!!!!!! PUUG!!! */
			break;
		default:
			fprintf(stderr,"Data type %02x not supported!\n",				
			  c->type);
			exit(1);
		}
		c=c->next;
	}

	return rc;
}

int
toCType(int dbType)
{
	switch (dbType) {
	case T_INT1:
	case T_BIT:
	case T_INT2:
	case T_INT4:
	case T_INTN:
	case T_DATETIME4:
	case T_DATETIME8:
	case T_DATETIMEN:
		return T_C_INTEGER;
	case T_FLOAT4:
	case T_FLOAT8:
	case T_FLOATN:
		return T_C_DOUBLE;
	case T_MONEY4:
	case T_MONEY8:
	case T_MONEYN:
		return T_C_LONGLONG;
	case T_VARBINARY:
	case T_VARCHAR:
	case T_BINARY:
	case T_CHAR:
		return T_C_STRING;
	case T_SENSITIVITY:
	case T_BOUNDARY:
	case T_DECIMAL:
	case T_NUMERIC:
	case T_LONGCHAR:
	case T_LONGBINARY:
	case T_IMAGE:
	case T_TEXT:
		return T_C_UNDEFINED;
	default:
		fprintf(stderr,"toCType: Unknown data type %02x.\n",dbType);
		return 0;
	}
}

int
handleRowData(MSSQL *s)
{
int i;
int rc;
void *val;
int maxlen;
int dbType;
COLUMN *c;

	for (i=0,rc=0,c=s->columns.next;i<s->columnCount;++i) {
		assert(c);

		if (rc&BUFFER_UNDERRUN)
			return BUFFER_UNDERRUN;
		if (rc&BUFFER_EMPTY)
			return BUFFER_EMPTY;

		rc=0;
		val=c->val;
		maxlen=c->maxlen;
		dbType=c->type;

		if (val && (toCType(dbType)==T_C_UNDEFINED || 
		            toCType(dbType)!=c->boundType)) {
			fprintf(stderr,"C type mismatch at column %d.\n",i);
			val=0;
		}

		switch (dbType) {
		case T_INT1:
		case T_BIT:
			rc|=read1Int(s,(int *)val);
			break;
		case T_INT2:
			rc|=read2Int(s,(int *)val);
			break;
		case T_INT4:
			rc|=read4Int(s,(int *)val);
			break;
		case T_INTN:
			rc|=readNInt(s,(int *)val);
			break;
		case T_FLOAT4:
			rc|=read4Float(s,(double *)val);
			break;
		case T_FLOAT8:
			rc|=read8Float(s,(double *)val);
			break;
		case T_FLOATN:
			rc|=readNFloat(s,(double *)val);
			break;
		case T_MONEY4:
			rc|=read4Money(s,(long long *)val);
			break;
		case T_MONEY8:
			rc|=read8Money(s,(long long *)val);
			break;
		case T_MONEYN:
			rc|=readNMoney(s,(long long *)val);
			break;
		case T_DATETIME4:
			rc|=read4Datetime(s,(time_t*)val);
			break;
		case T_DATETIME8:
			rc|=read8Datetime(s,(time_t*)val);
			break;
		case T_DATETIMEN:
			rc|=readNDatetime(s,(time_t*)val);
			break;
		case T_VARBINARY:
		case T_VARCHAR:
		case T_BINARY:
		case T_CHAR:
			rc|=readSmallString(s,(char *) val,maxlen);
			break;
		case T_SENSITIVITY:
			fprintf(stderr,"SENSITIVITY: not supported!\n");
			break;
		case T_BOUNDARY:
			fprintf(stderr,"BOUNDARY: not supported!\n");
			break;
		case T_DECIMAL:
		case T_NUMERIC:
			rc|=readNumeric(s,0);
			break;
		case T_LONGCHAR:
		case T_LONGBINARY:
			fprintf(stderr,"LONGCHAR | LONGBINARY: not supported!\n");
			break;
		case T_IMAGE:
		case T_TEXT:
			fprintf(stderr,"IMAGE | TEXT: not supported!\n");
			break;
		default:
			fprintf(stderr,"Data type %02x not supported!\n",				
			  c->type);
			exit(1);
		}
	}

	return rc;
}

int
handleEnvChange(MSSQL *s)
{
char buf1[4096];
char buf2[4096];
int type;
int rc;
int len;
	rc=read2Int(s,&len);
	rc|=read1Int(s,&type);
	if (s->verbose)
		fprintf(stderr,"Environment change: %02x: ",type);
	switch (type) {
	case 0x01:
		rc|=readSmallString(s,buf1,4095);
		rc|=readSmallString(s,buf2,4095);
		if (s->verbose)
			fprintf(stderr," current database: %s->%s\n",
		  buf2,buf1);
		break;
	case 0x04:
		rc|=readSmallString(s,buf1,4095);
		rc|=readSmallString(s,buf2,4095);
		if (s->verbose)
			fprintf(stderr," network packet: %s->%s\n",
		  buf2,buf1);
		break;
	default:
		doRead(s,(unsigned char *)buf1,len-1);
		dump(buf1,len-1,"");
		break;
	}
	return rc;
}

int
handleLoginAck(MSSQL *s)
{
int status;
unsigned char protoVersion[4];
char progName[33];
unsigned char progVersion[4];
int rc;
int len;

	rc=read2Int(s,&len);
	rc|=read1Int(s,&status);
	rc|=doRead(s,protoVersion,4);
	rc|=readSmallString(s,progName,32);
	rc|=doRead(s,progVersion,4);
	
	if (s->verbose)
		fprintf(stderr,"Login ACK: status: %d, program name: %s\n",
	  status,progName);

	return rc;
}

int
handleInfo(MSSQL *s)
{
char buf[33];
int rc;
int len;

	rc=read2Int(s,&len);
	rc|=doRead(s,0,6);
	rc|=readMediumString(s,buf,32);
	rc|=readSmallString(s,0,1);
	rc|=doRead(s,0,3);
	printf("Info: %s\n",buf);
	return rc;
}

int
handleError(MSSQL *s)
{
char buf[33];
int rc;
int len;

	rc=read2Int(s,&len);
	rc|=doRead(s,0,6);
	rc|=readMediumString(s,buf,32);
	rc|=readSmallString(s,0,1);
	rc|=doRead(s,0,3);
	printf("Error: %s\n",buf);
	return rc;
}

int
handleDone(MSSQL *s)
{
int status1;
int status2;
int count;
int rc;

	rc=read2Int(s,&status1);
	rc|=read2Int(s,&status2);
	rc|=read4Int(s,&count);
	if (s->verbose)
		fprintf(stderr,"Done: status1=%d,status2=%d,count=%d\n",
		  status1,status2,count);
	return rc;
}

int
handleToken(MSSQL *s,int token)
{
int rc;

/*
	printf("token=%02x\n",token);
*/

	switch (token) {
	case TOKEN_COL_NAMES:
		rc=handleColumnNames(s);
		break;
	case TOKEN_COL_METADATA:
		rc=handleMetaData(s);
		break;
	case TOKEN_ENV_CHANGE:
		rc=handleEnvChange(s);
		break;
	case TOKEN_LOGIN_ACK:
		rc=handleLoginAck(s);
		break;
	case TOKEN_INFO:
		rc=handleInfo(s);
		break;
	case TOKEN_ERROR:
		rc=handleError(s);
		break;
	case TOKEN_DONE1:
	case TOKEN_DONE2:
	case TOKEN_DONE3:
		rc=handleDone(s);
		break;
	case TOKEN_ROW_DATA:
		rc=handleRowData(s);
		break;
	}

	return rc;
}

int
doLogin(MSSQL *s,
  char *hostName,
  char *userName,
  char *password,
  char *id,
  char *appName,
  char *serviceName,
  char *language,
  char *charset
  )
{
/*char magic1[]= {0x02,0x00,0x04,0x06,0x08,0x01,0x01,0x00,0x00};*/
/*char magic1[]= {0x03,0x01,0x06,0x0a,0x09,0x01,0x01,0x00,0x00};*/
/*unsigned char magic1[]= {0x03,0x01,0x06,0x0a,0x09,0x01,0x01,0x00,0x00};*/
unsigned char magic1[]= {
#if defined(HW_LITTLE_ENDIAN)
                           0x03,0x01,
#elif defined(HW_BIG_ENDIAN)
                           0x02,0x00,
#endif
                                     0x06,0x0a,0x09,0x01,0x01,0x00,0x00};
unsigned char magic2[]= {0x00,0x00,0x00};
unsigned char protocolVersion[]= {0x04,0x02,0x00,0x00};
unsigned char magic3[]= {0x00,13,17};
unsigned char magic4[]= {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
unsigned char magic5=   0x01;
int rc;
int token;

	rc=writeString(s,hostName,30);
	rc|=writeString(s,userName,30);
	rc|=writeString(s,password,30);
	rc|=writeString(s,id,30);
	rc|=writeBuf(s,magic1,9);
	rc|=write4Int(s,0); /*512*/
	rc|=writeBuf(s,magic2,3);
	rc|=writeString(s,appName,30);
	rc|=writeString(s,serviceName,30);
	rc|=writeString(s,password,255);
	rc|=writeBuf(s,protocolVersion,4);
	rc|=writeString(s,"Pecioma",10);
	rc|=write4Int(s,0); /* 6 */
	rc|=writeBuf(s,magic3,3);
	rc|=writeString(s,language,30);
	rc|=writeBuf(s,magic4,14);
	rc|=writeString(s,charset,30);
	rc|=writeChar(s,magic5);
	rc|=writeString(s,"1024",6);
	rc|=write4Int(s,0);
	rc|=write4Int(s,0);
	rc|=flushMsSql(s);

	/*
		veakontroll siia - tegelt peaks olema iga kritseluse j#rel...
	*/

	while ((rc=read1Int(s,&token))==BUFFER_NOT_EMPTY) {
		if ((rc=handleToken(s,token))==BUFFER_UNDERRUN) {
			fprintf(stderr,"ARRGGHHH!!!\n");
			exit(1);
		}
	}

	resizeMsSql(s,4096);
	setFlag(s,1);

	return rc;
}
	
int execDirect(MSSQL *s,char *query)
{
int rc;
int token;

	writeBuf(s,query,strlen(query));
	flushMsSql(s);
	
	s->queryState=WAITING_ROW;

	while (s->queryState!=ROW_READY &&
	  (rc=read1Int(s,&token))==BUFFER_NOT_EMPTY) {
		if (handleToken(s,token)==BUFFER_UNDERRUN)
			break;
		switch (token) {
		case TOKEN_ROW_DATA:
			s->queryState=ROW_READY;
			break;
		case TOKEN_DONE1:
		case TOKEN_DONE2:
		case TOKEN_DONE3:
			s->queryState=DONE;
			break;
		}
	}

	return s->queryState;
}

int nextTuple(MSSQL *s)
{
int rc;
int token;

	if (s->queryState!=ROW_READY)
		return DONE;

	s->queryState=WAITING_ROW;

	while (s->queryState!=ROW_READY &&
	  (rc=read1Int(s,&token))==BUFFER_NOT_EMPTY) {
		if (handleToken(s,token)==BUFFER_UNDERRUN)
			break;
		switch (token) {
		case TOKEN_ROW_DATA:
			s->queryState=ROW_READY;
			break;
		case TOKEN_DONE1:
		case TOKEN_DONE2:
		case TOKEN_DONE3:
			s->queryState=DONE;
			break;
		}
	}

	return s->queryState;
}

void
printStats(MSSQL *s)
{
	fprintf(stderr,"Bytes in : %d\n",s->bytesIn);
	fprintf(stderr,"Bytes out: %d\n",s->bytesOut);
}

void
printColumnData(MSSQL *s)
{
COLUMN *c;

	for (c=s->columns.next;c;c=c->next) {
		printf("'%s': type=%s len=%d\n",
		  c->name,typeString(c->type),c->len);
	}
}
