#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdarg.h>
#include <unistd.h>
#include <fcntl.h>
#include "mssql.h"

void
my_assert_function(char* expr, char* filename, int linenumber)
{
        printf("my_assert: %s:%d: plaah_assertation:%s\n",
                 filename, linenumber, expr);
        exit(1);
}

void
dump(unsigned char *data,int len,char *comment)
{
int pos;
int i;
unsigned char dd;

	pos=0;
	printf("%s\n",comment);

	while (pos<len) {
		if (pos % 16==0)
			printf("\n%04x  ",pos);

		for (i=0;i<16;++i)
			if (i+pos < len)
				printf("%02x " ,data[pos+i]);
			else
				printf("   ");

		for (i=0;i<16;++i)
			if (i+pos < len) {
				dd=data[pos+i];
				if (!iscntrl(dd))
					printf("%c",dd);
				else
					printf(".");
			}

		pos+=16;
	}

	printf("\n\n");
	fflush(stdout);
}

int
openLog(MSSQL *s,char *path)
{
	s->logFd=open(path,O_CREAT|O_RDWR,0660);
	return (s->logFd!=-1);
}

void
appendLog(MSSQL *s,char *fmt,...)
{
va_list v;
int l;
char *buf;
int bl;

	bl=100;
	buf=(char *) malloc(bl);
	
	while (1) {
		va_start(v,fmt);
		l=vsnprintf(buf,bl,fmt,v);
		va_end(v);
		
		if (l>-1)
			break;
		
		bl+=100;
		realloc(buf,bl);
	};

	write(s->logFd,buf,l);
	write(s->logFd,"\n",1);
	free(buf);
}

void
closeLog(MSSQL *s)
{
	close(s->logFd);
}
